
#import <QuartzCore/QuartzCore.h>
#import "GestureSampleViewController.h"
#import "GestureView.h"

@implementation GestureSampleViewController



- (void)viewDidLoad {
    [super viewDidLoad];
	
	CGRect	frame = self.view.frame;
	GestureView*	gsview = [[GestureView alloc] initWithFrame:CGRectMake(0, 
																		   0, 
																		   frame.size.width, 
																		   frame.size.height)];
	[self.view addSubview:gsview];
	[gsview release];
	
	//ジェスチャー登録
	[self setGesture:gsview];
	
	ballView = [[UIView alloc] initWithFrame:CGRectMake(40, 40, 100, 100)];
	ballView.layer.contents = (id)[UIImage imageNamed:@"red.png"].CGImage;
	[gsview addSubview:ballView];
	[ballView release];
}

- (void)dealloc {
    [super dealloc];
}


/*-----------------------------------------------------------------------
 ジェスチャー登録
 -----------------------------------------------------------------------*/
-(void)setGesture:(UIView*)gsView {
	
	//タップ
	if( 1 ){
		//シングルタップ
		UITapGestureRecognizer*	
		tapRecog = [[[UITapGestureRecognizer alloc] initWithTarget:self 
															action:@selector(tapAction:)] autorelease];
		[gsView addGestureRecognizer:tapRecog];
		//ダブルタップ
		UITapGestureRecognizer*	
		tapRecog2 = [[[UITapGestureRecognizer alloc] initWithTarget:self 
															 action:@selector(tapAction:)] autorelease];
		tapRecog2.numberOfTapsRequired = 2;
		[gsView addGestureRecognizer:tapRecog2];
	}
	//ピンチ
	if( 1 ){
		UIPinchGestureRecognizer*	
		pinRecog = [[[UIPinchGestureRecognizer alloc] initWithTarget:self 
															  action:@selector(pinchAction:)] autorelease];
		[gsView addGestureRecognizer:pinRecog];
	}
	//フリックアクション
	if( 1 ) {
		//パン
		if( 1 ){
			UIPanGestureRecognizer*	
			panRecog = [[[UIPanGestureRecognizer alloc] initWithTarget:self 
																action:@selector(panAction:)] autorelease];
			[gsView addGestureRecognizer:panRecog];
		}
		//スワイプ
		else {
			//右
			UISwipeGestureRecognizer*	
			swpRecogR = [[[UISwipeGestureRecognizer alloc] initWithTarget:self 
																   action:@selector(swipeAction:)] autorelease];
			swpRecogR.direction = UISwipeGestureRecognizerDirectionRight;
			[gsView addGestureRecognizer:swpRecogR];
			//左
			UISwipeGestureRecognizer*	
			swpRecogL = [[[UISwipeGestureRecognizer alloc] initWithTarget:self 
																   action:@selector(swipeAction:)] autorelease];
			swpRecogL.direction = UISwipeGestureRecognizerDirectionLeft;
			[gsView addGestureRecognizer:swpRecogL];
			//上
			UISwipeGestureRecognizer*	
			swpRecogU = [[[UISwipeGestureRecognizer alloc] initWithTarget:self 
																   action:@selector(swipeAction:)] autorelease];
			swpRecogU.direction = UISwipeGestureRecognizerDirectionUp;
			[gsView addGestureRecognizer:swpRecogU];
			//下
			UISwipeGestureRecognizer*	
			swpRecogD = [[[UISwipeGestureRecognizer alloc] initWithTarget:self 
																   action:@selector(swipeAction:)] autorelease];
			swpRecogD.direction = UISwipeGestureRecognizerDirectionDown;
			[gsView addGestureRecognizer:swpRecogD];
		}
	}
	//回転
	if( 1 ){
		UIRotationGestureRecognizer*	
		rotRecog = [[[UIRotationGestureRecognizer alloc] initWithTarget:self 
																 action:@selector(rotationAction:)] autorelease];
		[gsView addGestureRecognizer:rotRecog];
	}
	//長押し
	if( 1 ){
		UILongPressGestureRecognizer*	
		prsRecog = [[[UILongPressGestureRecognizer alloc] initWithTarget:self 
																  action:@selector(longpressAction:)] autorelease];
		[gsView addGestureRecognizer:prsRecog];
	}
}


/*-----------------------------------------------------------------------
 スワイプ
 -----------------------------------------------------------------------*/
-(void)swipeAction:(UISwipeGestureRecognizer*)sender {
	
	float	val = 50;
	CGPoint	pt = ballView.center;
	//左へスワイプ
	if( sender.direction == UISwipeGestureRecognizerDirectionLeft ){
		NSLog(@"左へスワイプ");
		ballView.center = CGPointMake(pt.x-val, pt.y);
	}
	//右へスワイプ
	else if( sender.direction == UISwipeGestureRecognizerDirectionRight ){
		NSLog(@"右へスワイプ");
		ballView.center = CGPointMake(pt.x+val, pt.y);
	}
	//下へスワイプ
	else if( sender.direction == UISwipeGestureRecognizerDirectionDown ){
		NSLog(@"下へスワイプ");
		ballView.center = CGPointMake(pt.x, pt.y+val);
	}
	//上へスワイプ
	else if( sender.direction == UISwipeGestureRecognizerDirectionUp ){
		NSLog(@"上へスワイプ");
		ballView.center = CGPointMake(pt.x, pt.y-val);
	}
}

/*-----------------------------------------------------------------------
 パン
 -----------------------------------------------------------------------*/
-(void)panAction:(UIPanGestureRecognizer*)sender {
	
	CGPoint	tpt = [sender translationInView:sender.view];	//移動値
	CGPoint	vpt = [sender velocityInView:sender.view];		//速度
	
	NSLog(@"移動値: x=%f y=%f  速度: x=%f y=%f",tpt.x, tpt.y, vpt.x, vpt.y);
	
	CGPoint	pt = ballView.center;
	ballView.center = CGPointMake(pt.x+(vpt.x*0.01), pt.y+(vpt.y*0.01));
}


/*-----------------------------------------------------------------------
 タップ
 -----------------------------------------------------------------------*/
-(void)tapAction:(UITapGestureRecognizer*)sender {
	
	int		taps = sender.numberOfTapsRequired;
	
	NSLog(@"タップ: %d", taps);
	
	if(taps==2 ){
		//元の位置と回転角とスケールに戻す
		CGAffineTransform	transform1 = CGAffineTransformMakeRotation(0);
		CGAffineTransform	transform2 = CGAffineTransformMakeScale(1,1);
		ballView.transform = CGAffineTransformConcat(transform1,transform2);
		ballView.frame = CGRectMake(40, 40, 100, 100);
		ballView.layer.contents = (id)[UIImage imageNamed:@"red.png"].CGImage;
	}
}

/*-----------------------------------------------------------------------
 ピンチ
 -----------------------------------------------------------------------*/
-(void)pinchAction:(UIPinchGestureRecognizer*)sender {
	
	NSLog(@"スケール: %.2f   速度: %.2f", sender.scale, sender.velocity);
	
	CGAffineTransform	transform = CGAffineTransformMakeScale(sender.scale,sender.scale);
	ballView.transform = transform;
}

/*-----------------------------------------------------------------------
 回転
 -----------------------------------------------------------------------*/
-(void)rotationAction:(UIRotationGestureRecognizer*)sender {
	
	NSLog(@"回転角度: %.2f   速度: %.2f", (sender.rotation*180.0)/3.14159265358979, sender.velocity);
	
	CGAffineTransform	transform = CGAffineTransformMakeRotation(sender.rotation);
	ballView.transform = transform;
}

/*-----------------------------------------------------------------------
 長押し
 -----------------------------------------------------------------------*/
-(void)longpressAction:(UILongPressGestureRecognizer*)sender {
	
	NSString	*str=nil;
	UIGestureRecognizerState	state = sender.state;
    
	if(state==UIGestureRecognizerStatePossible){
		str = @"UIGestureRecognizerStatePossible";
	}
    else if(state==UIGestureRecognizerStateBegan){
		str = @"UIGestureRecognizerStateBegan";
	}
    else if(state==UIGestureRecognizerStateChanged){
		str = @"UIGestureRecognizerStateChanged";
	}
    else if(state==UIGestureRecognizerStateEnded){
		str = @"UIGestureRecognizerStateEnded";
	}
    else if(state==UIGestureRecognizerStateCancelled){
		str = @"UIGestureRecognizerStateCancelled";
	}
    else if(state==UIGestureRecognizerStateFailed){
		str = @"UIGestureRecognizerStateFailed";
	}
	
	NSLog(@"長押し: %@", [self class], str);
	
	ballView.layer.contents = (id)[UIImage imageNamed:@"blue.png"].CGImage;
}

@end
